//Test
class simple_test extends uvm_test;
    sequencer   sqr;
    sequence_in seq;
    driver      drv;
    monitor     mnt;
    sink      sk;
    uvm_tlm_analysis_fifo #(packet_in) fifo;

    `uvm_component_utils(simple_test)

    function new(string name, uvm_component parent = null);
        super.new(name, parent);
        fifo = new("fifo", this);  // cannot use factory
    endfunction

    virtual function void build_phase(uvm_phase phase);
        super.build_phase(phase);
        sqr = sequencer::type_id::create("sqr", this);
        seq = sequence_in::type_id::create("seq", this);
        drv = driver::type_id::create("drv", this);
        mnt = monitor::type_id::create("mnt", this);
        sk = sink::type_id::create("sk", this);
    endfunction

    virtual function void connect_phase(uvm_phase phase);
        super.connect_phase(phase);
        drv.seq_item_port.connect(sqr.seq_item_export); 
        mnt.item_collected_port.connect(fifo.analysis_export);
        sk.in.connect(fifo.get_export);
    endfunction
 
    task run_phase(uvm_phase phase);
        phase.raise_objection(this, "Inicio da simulacao");
        seq.start(sqr);
    endtask: run_phase
endclass
