//Test
class simple_test extends uvm_test;
    sequence_in seq;
    agent       mst;
    sink        sk;
    uvm_tlm_analysis_fifo #(packet_in) fifo;

    `uvm_component_utils(simple_test)

    function new(string name, uvm_component parent = null);
        super.new(name, parent);
        fifo = new("fifo", this);  // cannot use factory
    endfunction

    virtual function void build_phase(uvm_phase phase);
        super.build_phase(phase);
        seq = sequence_in::type_id::create("seq", this);
        mst = agent::type_id::create("mst", this);
        sk  = sink::type_id::create("sk", this);
    endfunction

    virtual function void connect_phase(uvm_phase phase);
        super.connect_phase(phase);
        mst.item_collected_port.connect(fifo.analysis_export);
        sk.in.connect(fifo.get_export);
    endfunction

    task run_phase(uvm_phase phase);
        phase.raise_objection(this, "Inicio da simulacao");
        seq.start(mst.sqr);
    endtask: run_phase
endclass
