//Test
class simple_test extends uvm_test;
    sequence_in seq;
    agent       mst;
    refmod      rfm;
    driver_out  drv_out; 
    monitor_out mon_out;
    sink        sk;
    
    uvm_tlm_analysis_fifo #(packet_in) to_refmod;
    uvm_tlm_fifo #(packet_out) to_sink;

    `uvm_component_utils(simple_test)

    function new(string name, uvm_component parent = null);
        super.new(name, parent);
        to_refmod = new("to_refmod", this);  // cannot use factory
        to_sink = new("to_sink", this);
    endfunction

    virtual function void build_phase(uvm_phase phase);
        super.build_phase(phase);
        seq = sequence_in::type_id::create("seq", this);
        mst = agent::type_id::create("mst", this);
        rfm = refmod::type_id::create("rfm", this);
        sk  = sink::type_id::create("sk", this);
        drv_out = driver_out::type_id::create("drv_out", this);
        mon_out = monitor_out::type_id::create("mon_out", this);
    endfunction

    virtual function void connect_phase(uvm_phase phase);
        super.connect_phase(phase);
        mst.item_collected_port.connect(to_refmod.analysis_export);
        rfm.in.connect(to_refmod.get_export);
        rfm.out.connect(to_sink.put_export);
        sk.in.connect(to_sink.get_export);
    endfunction

    task run_phase(uvm_phase phase);
        phase.raise_objection(this, "Inicio da simulacao");
        seq.start(mst.sqr);
    endtask: run_phase
endclass
