//Test
class simple_test extends uvm_test;
    sequence_in seq;
    agent       mst;
    refmod      rfm;
    sink        sk;
    agent_out   slv;
    comparator #(packet_out) comp;  
    
    uvm_tlm_analysis_fifo #(packet_in) to_refmod;


    `uvm_component_utils(simple_test)

    function new(string name, uvm_component parent = null);
        super.new(name, parent);
        to_refmod = new("to_refmod", this);  // cannot use factory
        
    endfunction

    virtual function void build_phase(uvm_phase phase);
        super.build_phase(phase);
        seq = sequence_in::type_id::create("seq", this);
        mst = agent::type_id::create("mst", this);
        rfm = refmod::type_id::create("rfm", this);
        slv = agent_out::type_id::create("slv", this);
        comp = comparator#(packet_out)::type_id::create("comp", this);
    endfunction

    virtual function void connect_phase(uvm_phase phase);
        super.connect_phase(phase);
        mst.item_collected_port.connect(to_refmod.analysis_export);
        rfm.in.connect(to_refmod.get_export);
        rfm.out.connect(comp.from_refmod);
        slv.item_collected_port.connect(comp.from_dut);
    endfunction

    task run_phase(uvm_phase phase);
        seq.start(mst.sqr);
    endtask: run_phase
    
    virtual function void report_phase(uvm_phase phase);
        super.report_phase(phase);
        `uvm_info(get_type_name(), $sformatf("Reporting matched %0d", comp.m_matches), UVM_NONE)
        if (comp.m_mismatches) begin
            `uvm_error(get_type_name(), $sformatf("Saw %0d mismatched samples", comp.m_mismatches))
        end
    endfunction
endclass
